/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

Node *se_current_statement;

/***************************** C H E C K **************************************/

Node *check_Statement_down (root)
Node *root;
{
	se_current_statement = root;

	return root;
}

Node *check_Statement (root)
Node *root;
{
	if (root == NN || root->Statement.Stmt == NN || root->Statement.Stmt == &IgnoreStmt)
		return root;

	root->Statement.Stmt
	= do_check_Statement (root->Statement.IntegerConstant, root->Statement.Stmt);

	return root;
}

/***************************** T R A N S **************************************/

/***************************** W R I T E **************************************/

write_Statement (node)
Node *node;
{
	PtF fun;
	Node *label;
	int was_replaced = 0, type;
	T_Entry *entry;
	struct S_Statement *sta = &node->Statement;

	if (node == NN || sta->Stmt == &IgnoreStmt)
		return;

/*!!! moved this here, was after write_sta_bef. Fri Jun 28 16:06:12 PDT 1991 */

	if ((fun = order (node->Statement.Stmt)) != (PtF) 0)
		(*fun)();

	if (sta->fun != (PtF) 0) {
		(*sta->fun)(sta->arg);
	}
	else {
		source_dump_orig (sta->file, sta->line);

		type = sta->Stmt->com.type;

		if (order_is_exec (type)
		&& type != CONTINUE_STMT
		&& type != END_DO_STMT
		&& type != END_STMT
		&& type != FORMAT_STMT) {
			if (sta->IntegerConstant != NN)
				o_continue (sta->IntegerConstant);

			if (sta->Stmt != NN
			&& !se_in_where
			&& type != FORALL_STMT
			&& type != CASE_CONSTRUCT
			&& type != DO_CONSTRUCT
			&& type != WHERE_CONSTRUCT
			&& type != IF_CONSTRUCT)
				sta_write_sta_bef (node);

			if (order_is_construct (type))
				write_pass (sta->Stmt);
			else {
				
                                if(type== ASSIGNEMENT_STMT)
                                { /* it will not write assignement statement 
                                     if its str is "REMOVE", not NULL */
                                    if(sta->Stmt->AssignementStmt.str)
                                    ;
                                    else {
                                           oTab ();
                                           write_pass (sta->Stmt);
			                   oDon ();
					 }

                                }
                                else {
                                  oTab ();
                                  write_pass (sta->Stmt);
			          oDon ();
				}
			
			      }
		      }
		else {  /* non executable statements */
			sta_write_sta_bef (node);

			ostart ();

			if (sta->IntegerConstant != NN)
				olab (sta->IntegerConstant);

	/*		otab ();*/  /* ZEKI */
	                if(type!=DIRECTIVE_STMT) otab ();
                        else ostr("C     ");

			write_pass (sta->Stmt);
			oDon ();
		}
	}

	array_end_statement_write ();

	if (sta->Stmt != NN
	&& !se_in_where
	&& type != FORALL_STMT
	&& type != DO_CONSTRUCT
	&& type != CASE_CONSTRUCT
	&& type != WHERE_CONSTRUCT
	&& type != IF_CONSTRUCT)
		sta_write_sta_aft (node);
}

/* next two are not static just because we need them for the hack in forall.c */

sta_write_sta_bef (node)
Node *node;
{
	int i;
	Trans *trans;
	int type;
#ifdef CHECK
	static int debug_loc = 0;
	static int tab_level = 0;
#endif CHECK

	if (node == NN)
		return;

	type = node->com.type;

#ifdef CHECK
	if (debug_loc) {
		for (i = 0; i < tab_level; i++) {
			putchar ('|');
			putchar (' ');
		}
	
		printf ("%s", node_Symbol (type));
		if (node->com.str != CN && *node->com.str != '\n')
			printf (" (%s)", node->com.str);
		tab_level++;
	}
#endif CHECK

	if ((trans = node->com.trans) != TRN) {
#ifdef CHECK
		if (debug_loc)
			printf (": D-U-M-P-I-N-G\n", node_Symbol (type));
#endif CHECK

		for (i = 0; i < trans->nbef; i++)
			write_Statement (trans->sta_bef [i]);

/* so that when we do a Block statement, they don't get written again in the
statements inside the Block. Sat Jun 22 17:48:56 PDT 1991 */

		trans->nbef = 0;
	}

#ifdef CHECK
	if (debug_loc)
		putchar ('\n');
#endif CHECK

/* The reason for going backwards in the loop is that in 
   expr1 = expr2
   we need to do the stuff for expr2 before the one for expr1 */

	for (i = node_nodes (type) - 1; i >= 0; i--)
		sta_write_sta_bef (node->com.node [i]);

#ifdef CHECK
	if (debug_loc)
		tab_level--;
#endif CHECK
}

sta_write_sta_aft (node)
Node *node;
{
	int i;
	Trans *trans;
	int type;

	if (node == NN)
		return;

	type = node->com.type;

	if ((trans = node->com.trans) != TRN) {
		for (i = 0; i < trans->naft; i++)
			write_Statement (trans->sta_aft [i]);

/* so that when we do a Block statement, they don't get written again in the
statements inside the Block. Sat Jun 22 17:48:56 PDT 1991 */

		trans->naft = 0;
	}

	for (i = node_nodes (type) - 1; i >= 0; i--)
		sta_write_sta_aft (node->com.node [i]);
}

sta_write_trans_aft (trans)
Trans *trans;
{
	int i;

	if (trans != TRN)
		for (i = 0; i < trans->naft; i++)
			write_Statement (trans->sta_aft [i]);
}

sta_write_trans_bef (trans)
Trans *trans;
{
	int i;

	if (trans != TRN)
		for (i = 0; i < trans->nbef; i++)
			write_Statement (trans->sta_bef [i]);
}
